﻿<cfcomponent>
	
	<cfset this.cart = arrayNew(1)>
	<cfset this.dsn = "">
	<cfset this.orderID = 0>
	<cfset this.offeringID = 0>
	<cfset this.message = "">
	<cfset this.errorMessage = "">
	
	<cffunction name="init" access="public" returntype="struct">
		<cfargument name="arg_datasource" default="" required="yes" type="string">
		<cfset this.dsn = arguments.arg_datasource>
		<cfreturn this>
	</cffunction>
	<!---  AND arguments.arg_itemQty NEQ 0 --->
	<cffunction name="addItem" access="public" returntype="any" output="yes">
		<cfargument name="arg_itemID" default="0" required="yes" type="numeric">
		<cfargument name="arg_itemQty" default="0" required="yes" type="numeric">
		<cfscript>
			if (isUnique(arguments.arg_itemID)){
				arrayAppend(this.cart,structNew());
				thisCartItem = arraylen( this.cart );
				this.cart[thisCartItem].itemID = arguments.arg_itemID;
				this.cart[thisCartItem].requestedQty = arguments.arg_itemQty;
				this.cart[thisCartItem].shipping = "Address";
				this.cart[thisCartItem].message = "";
				limit = checkQtyLimit(arguments.arg_itemID);
				currentInventory = getWineQtyonHand(this.cart[thisCartItem].itemID);
				
				if(arguments.arg_itemQty LTE limit and arguments.arg_itemQty LTE currentInventory){
					if(arguments.arg_itemQty GT currentInventory){
						this.cart[thisCartItem].quantity = currentInventory;
						this.cart[thisCartItem].message = "*Due to current inventory your order has been adjusted.";
					}else{
						this.cart[thisCartItem].quantity = arguments.arg_itemQty;
					}
				}else{
					if(arguments.arg_itemQty GT currentInventory){
						this.cart[thisCartItem].quantity = currentInventory;
						this.cart[thisCartItem].message = "*Due to current inventory your order has been adjusted.";
					}else{	
						this.cart[thisCartItem].quantity = limit;
						this.cart[thisCartItem].message = "*The quantity you requested exceeds the max allowed. Your order has been adjusted.";
						this.message = this.cart[thisCartItem].message;
					}
				}
			}
		</cfscript>
	</cffunction>
	
	<cffunction name="getItemDetails" access="public" returntype="query">
		<cfargument name="arg_itemID" default="0" required="yes" type="numeric">
		<cfquery name="getData" datasource="#this.dsn#">
			SELECT *
			FROM tblWines
			WHERE wt_wineID = #arguments.arg_itemID#
		</cfquery>
		<cfreturn getData>	
	</cffunction>
	
	<cffunction name="isUnique" access="private" returntype="boolean">
		<cfargument name="arg_itemID" required="yes" type="numeric">
		<cfset var isUnigueValue = true>
		<cfloop index="thisCartItem" from="1" to="#arrayLen(this.cart)#">
			<cfif this.cart[thisCartItem].itemID eq arguments.arg_itemID>
				<cfset isUnigueValue = false>
				<cfreturn isUnigueValue>
			</cfif>
		</cfloop>
		<cfreturn isUnigueValue>	
	</cffunction>
	
	
	<cffunction name="checkQtyLimit" access="public" returntype="any">
		<cfargument name="arg_itemID" required="yes" type="numeric">
		<cfset var limit = 0>
			<cfquery name="getLimit" datasource="#this.dsn#">
			SELECT wt_maxQtyPerOrder
			FROM tblWines
			WHERE wt_wineID = #arguments.arg_itemID#
		</cfquery>		
		<cfset limit = getLimit.wt_maxQtyPerOrder>
		<cfreturn limit>	
	</cffunction>
	
	
	<cffunction name="updateItem" access="public" returntype="any">
		<cfargument name="arg_itemID" required="yes" type="any">
		<cfargument name="arg_itemQty" required="yes" type="any">

		<cfloop index="thisCartItem" from="1" to="#arrayLen(this.cart)#">
			<cfif this.cart[thisCartItem].itemID eq arguments.arg_itemID>
				<cfscript>
						limit = checkQtyLimit(arguments.arg_itemID);
						currentInventory = getWineQtyonHand(this.cart[thisCartItem].itemID);
						this.cart[thisCartItem].requestedQty = arguments.arg_itemQty;
						this.cart[thisCartItem].message = "";
						if(arguments.arg_itemQty LTE limit and arguments.arg_itemQty LTE currentInventory){
							this.cart[thisCartItem].quantity = arguments.arg_itemQty;
						}else{
							if(arguments.arg_itemQty GT limit ){
								this.cart[thisCartItem].quantity = limit;
								this.cart[thisCartItem].message = "*The quantity you requested exceeds the max allowed. Your order has been adjusted.";
								
							}else if(arguments.arg_itemQty GT currentInventory){	
								this.cart[thisCartItem].quantity = currentInventory;
								this.cart[thisCartItem].message = "*Due to current inventory your order has been adjusted.";
								this.message = this.cart[thisCartItem].message;
							}
						}
					
				</cfscript>
			</cfif>
		</cfloop>

	</cffunction>
	
	<cffunction name="updateShipping" access="public" returntype="any">
		<cfargument name="arg_itemID" required="yes" type="any">
		<cfargument name="arg_shippingMethod" required="yes" type="any">

		<cfloop index="thisCartItem" from="1" to="#arrayLen(this.cart)#">
			<cfif this.cart[thisCartItem].itemID eq arguments.arg_itemID>
				<cfscript>
					this.cart[thisCartItem].shipping = arguments.arg_shippingMethod;		
				</cfscript>
			</cfif>
		</cfloop>

	</cffunction>
	
	<cffunction name="checkState" access="public" returntype="boolean">
		<cfargument name="arg_state" required="yes" type="string">
		<cfset var shippingAllowed = true>
		
		<cfquery name="getStateData" datasource="#this.dsn#">
			SELECT rst_stateid
			FROM tblRestrictedStates
			WHERE rst_stateName = '#arguments.arg_state#'
		</cfquery>
		
		<cfif getStateData.RecordCount GT 0>
			<cfset shippingAllowed = false>
		</cfif>
		<cfreturn shippingAllowed>
	</cffunction>
	
	<cffunction name="setOfferingID" access="public" returntype="any">
		<cfargument name="arg_offeringID" required="yes" type="numeric">
		<cfset this.offeringID = arguments.arg_offeringID>	
	</cffunction>
	
	<cffunction name="getOrderInfo" access="public" returntype="boolean" output="yes">
		<cfargument name="arg_form" required="yes" type="struct">
		<cfset var successfull = true>
		
		<cftry>
			<cfif this.orderID EQ 0>
				<cfquery name="insertOrderInfo" datasource="#this.dsn#">
					SET NOCOUNT ON
					INSERT INTO tblOrders
								(
									to_offeringID
									,to_membershipID
									,to_emailAddress
									,to_firstName
									,to_lastName
									,to_address
									,to_address2
									,to_state
									,to_city
									,to_zipCode
									,to_phoneNumber
								)
					VALUES
						(
							#this.offeringID#
							,#arguments.arg_form.membershipID#
							,'#arguments.arg_form.email#'
							,'#arguments.arg_form.fName#'
							,'#arguments.arg_form.lName#'
							,'#arguments.arg_form.address#'
							,'#arguments.arg_form.address2#'
							,'#arguments.arg_form.state#'
							,'#arguments.arg_form.city#'
							,'#arguments.arg_form.zipcode#'
							,'#arguments.arg_form.phone#'	
						)
					SELECT @@Identity AS newId      
					SET NOCOUNT OFF  
				</cfquery>
				<cfset this.orderID  = insertOrderInfo.newId>
			</cfif>
		<cfcatch type="any">
			<cfdump var="#cfcatch#">
			<cfset successfull = false>
		</cfcatch>
		</cftry>
		<cfreturn successfull>
	</cffunction>
	
	<cffunction name="finalizeOrder" access="public" returntype="any">
		
		<cftransaction action="begin" />
			<cfloop index="thisCartItem" from="1" to="#arrayLen(this.cart)#">
				<cfscript>
					dupOrder = checkDupOrder(this.cart[thisCartItem].itemID);
							
				</cfscript>
				<cfif NOT dupOrder>
					<cftry>			
						<cfquery name="insertWineOrder" datasource="#this.dsn#">
							INSERT INTO tblOrderToWineLU
												(
													owt_orderID
													,owt_wineID
													,owt_qtyRequested
													,owt_qtyOrdered
													,owt_shippingMethod
												)
							
							
							VALUES
								(
									#this.orderID#
									,#this.cart[thisCartItem].itemID#
									,#this.cart[thisCartItem].requestedQty#
									,#this.cart[thisCartItem].quantity#
									,'#this.cart[thisCartItem].shipping#'
									
								
								)
						
						
						</cfquery>
					<cfcatch type="database">
						<cfset this.errorMessage = "There was an error trying to process your order">
						<cftransaction action="rollback" />
						<cfreturn this.errorMessage>
					</cfcatch>	
					</cftry>		
					<cfscript>
						currentInventory = getWineQtyonHand(this.cart[thisCartItem].itemID);
						updatedInventory = (currentInventory - this.cart[thisCartItem].quantity) ;
						updateWineQtyonHand(this.cart[thisCartItem].itemID,updatedInventory);					
					</cfscript>
				</cfif>
			</cfloop>
		<cftransaction action="commit" />		
		<cfreturn this.orderID>	
	</cffunction>
	
	<cffunction name="getWineQtyonHand" access="public">
		<cfargument name="arg_wineID" required="yes" type="numeric">
		<cfset var inventory = 0>
		<cfquery name="getWineInventory" datasource="#this.dsn#">
			SELECT wt_qtyOnHand
			FROM tblWines
			WHERE wt_wineID = #arguments.arg_wineID#
		</cfquery>
		<cfset inventory = getWineInventory.wt_qtyOnHand>
		<cfreturn inventory>
	</cffunction>

	<cffunction name="updateWineQtyonHand" access="public">
		<cfargument name="arg_wineID" required="yes" type="numeric">
		<cfargument name="arg_newAmount" required="yes" type="numeric">
		<cfquery name="getWineInventory" datasource="#this.dsn#">
			UPDATE tblWines
			SET wt_qtyOnHand = #arguments.arg_newAmount#
			,wt_modifiedDate = '#DateFormat(Now(),'mm/dd/yyyy')#'
			WHERE wt_wineID = #arguments.arg_wineID#
		</cfquery>
	</cffunction>
	
	<cffunction name="checkDupOrder" access="public">
		<cfargument name="arg_wineID" required="yes" type="numeric">
		<cfset var isDuplicateOrder = false>
		<cfquery name="getWineOrder" datasource="#this.dsn#">
			SELECT owt_id
			FROM dbo.tblOrderToWineLU
			WHERE owt_wineID = #arguments.arg_wineID#
			AND owt_orderID = #this.orderID#
		</cfquery>
		
		<cfif getWineOrder.RecordCount GT 0>
			<cfset isDuplicateOrder = true>
		</cfif>		
		<cfreturn isDuplicateOrder>
	</cffunction>
	
	<cffunction name="getOrderDetails" access="public">
		<cfquery name="getContactInfo" datasource="#this.dsn#">
			SELECT *
			FROM tblOrders
			WHERE to_orderID = #this.orderID#			
		</cfquery>
	<cfreturn getContactInfo>
	</cffunction>
	
</cfcomponent>