<!--- orderConfirmation.cfm --->

<cfset docTitle="">
<cfset pageHeader="Please Confirm Your Order">
<cfset metadesc="">
<cfset keywords="">

<cfparam name="shippingAllowed" default="true">
<cfif Not isDefined('session.shoppingCart')>
	<cflocation url="index.cfm" addtoken="no">
</cfif>
<cfset shippingAllowed = session.shoppingCart.checkState(form.state)>
<cfset captureOrderInfo = session.shoppingCart.getOrderInfo(form)>

<cfquery name="getAdminInfo" datasource="#application.dsn#">
	SELECT top 1 at_taxRate
	FROM tblAdmin			
</cfquery>

<cfsavecontent variable="loadScript">
	<script>
	<!--- 
		function cancelOrder(
			var f = new Object(form);	
			f.action = 'shoppingcart.cfm';
			f.submit();
		) --->
	</script>
</cfsavecontent>
<cfsavecontent variable="bodyContent">
	<cfoutput>
		<cfif shippingAllowed EQ False>
			<div class="note" style="padding-bottom:15px;">*State is restricted for shipping, please contact <a href="mailto:ldarling@mayacama.com" class="note" style="font-size:.9em;">ldarling@mayacama.com</a> for assistance.</div>
		</cfif>
		<table width="550" id="shoppingcart" cellpadding="2" cellspacing="0" border="0">
		<form name="itemFrm" action="final.cfm" method="post">
			<tr>
				<th width="65px;">Ship Type</th>
				<th class="special" align="left" style="padding-left:15px;">Item</th>
				<th nowrap="nowrap">Price Per Bottle</th>
				<th>Quantity</th>
				<th nowrap="nowrap">Subtotal</th>								
			</tr>
			
			<cfset grandTotal = 0>
			
			<cfloop index="thisCartItem" from="1" to="#arrayLen(session.shoppingCart.cart)#">
				<cfif session.shoppingCart.cart[thisCartItem].quantity NEQ 0>
					<cfset id = session.shoppingCart.cart[thisCartItem].itemID>
					<cfset price = session.shoppingCart.getItemDetails(id).wt_price>
					<cfset qty = session.shoppingCart.cart[thisCartItem].quantity>
					<cfset extendedPrice = price * qty>
					<cfset grandTotal = grandTotal + extendedPrice>
					<tr>
						<td nowrap="nowrap">
							<input type="radio" name="shiptype_#id#" value="Locker"  #IIF(shippingAllowed EQ true,DE(''),DE('checked="checked"'))#/>Locker
							<input type="radio" name="shiptype_#id#" value="Address" #IIF(shippingAllowed EQ true,DE('checked="checked"'),DE('disabled="disabled"'))#/>Address
						</td>								
						<td class="special" nowrap="nowrap" align="left" style="padding-left:15px;">
							#Trim(session.shoppingCart.getItemDetails(id).wt_wineName)#
						</td>
						<td align="center">
							#DollarFormat(price)#
						</td>
						<td align="center">#qty#</td>
						<td class="dollar">
							#DollarFormat(extendedPrice)#
						</td>
					</tr>
				</cfif>
			</cfloop>
			<cfset taxes = grandTotal * getAdminInfo.at_taxRate>
			<cfset subtotal = grandTotal>
			<cfset grandTotal = grandTotal + taxes>
			<tr>
				<td colspan="3">&nbsp;</td>
				<td class="dollar" style="padding-top:10px;">Subtotal:</td>
				<td style="padding-top:10px;" class="dollar">#DollarFormat(subtotal)#</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
				<td align="right" class="dollar" nowrap="nowrap">Tax Rate #getAdminInfo.at_taxRate * 100#%:</td>
				<td class="dollar">#DollarFormat(taxes)#</td>
			</tr>
			<tr>
				<td colspan="3">&nbsp;</td>
				<td nowrap="nowrap" class="dollar" >Grand Total:</td>
				<td class="dollar">#DollarFormat(grandTotal)#</td>
			</tr>
			<tr>
				<td colspan="5" align="center">
				<input style="font-size:12px;" class="submitBtn" name="btnFinalize" type="submit" value="Finalize Order" /></td>
			</tr>
		</form>
			<form name="checkoutFrm" action="shoppingcart.cfm" method="post">
			<tr>
				<td colspan="5" class="submitBtn" align="center">
				<input type="submit" value="Cancel Order" name="btnCancel" onclick="cancelOrder();" /></td>
				
			</tr>
			</form>
		</table>
		
	</cfoutput>
</cfsavecontent>

<cfinclude template="layouts/lay_default.cfm">	
					