<!--- winedetails.cfm --->

<cfparam name="url.id" default="0">

<cfquery name="getData" datasource="#application.dsn#">
	SELECT     
		tblWines.wt_qtyOnHand
		, tblWines.wt_maxQtyPerOrder
		, tblWines.wt_year
		, tblWines.wt_shortDescription
		, tblWines.wt_description
		, tblWines.wt_readilyAvailable
		, tblWines.wt_price
		, tblRegion.rt_region
		, tblRegion.rt_country
		, tblWineTypes.wtt_name
		, tblWineTypes.wtt_description
		, tblVintner.vt_name as vintner
		, tblVintner.vt_description
		, tblVarieties.vt_name
		, tblVarieties.vt_name as varietal
		, tblWines.wt_wineName
		, tblWines.wt_wineID
		, tblWines.wt_lowthreshold
		, tblWines.wt_thresholdMessage,tblVintner.vt_isMember
	FROM         tblWines INNER JOIN
					  tblVintner ON tblWines.wt_vintnerID = tblVintner.vt_vintnerID INNER JOIN
					  tblVarieties ON tblWines.wt_varietiesID = tblVarieties.vt_id INNER JOIN
					  tblRegion ON tblWines.wt_regionID = tblRegion.rt_id INNER JOIN
					  tblWineTypes ON tblWines.wt_wineTypeID = tblWineTypes.wtt_ID
	WHERE wt_wineID = #url.id#
</cfquery>

<cfoutput query="getData">
	<cfset pageHeader = "#vintner# #wt_wineName# #wt_year#">
	<cfset docTitle = pageHeader>
	<cfset metadesc="#wt_shortDescription#">
	<cfset keywords="#wt_wineName# #wt_year# #dollarFormat(wt_price)# #rt_region# #rt_country# #wtt_name# #vintner# #varietal#">
</cfoutput>
	
<cfsavecontent variable="bodyContent">	
	<table>
	<cfoutput>
		<tr>	
			<td class="offer">
				Type			
			</td>
			<td  class="offerDetails">
				#getData.wtt_name#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Varietal			
			</td>
			<td class="offerDetails">
				#getData.varietal#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Vintner #IIF(getData.vt_isMember,DE('*'),DE(''))#			
			</td>
			<td class="offerDetails">
				#getData.vintner#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Name			
			</td>
			<td class="offerDetails">
				#getData.wt_wineName#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Year			
			</td>
			<td class="offerDetails">
				#getData.wt_year#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Country/St			
			</td>
			<td class="offerDetails">
				#getData.rt_country#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Region			
			</td>
			<td class="offerDetails">
				#getData.rt_region#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Price Per Bottle			
			</td>
			<td class="offerDetails">
				#DollarFormat(getData.wt_price)#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Brief Description			
			</td>
			<td class="offerDetails">
				#getData.wt_shortDescription#
			</td>
		</tr>
		<tr>	
			<td class="offer">
				Full Description			
			</td>
			<td class="offerDetails">
				#getData.wt_description#
			</td>
		</tr>
		</cfoutput>
		<tr>
			<td class="close" colspan="2"><a href="javascript:void();" onclick="javascript:window.close();"> Close Window</a></td>
		</tr>
	</table>
</cfsavecontent>

<cfinclude template="layouts/lay_popup.cfm">
	
